BASE:E( "** UH-60L 003 - Outpost 387 By Element **")
local Mission = {}

Mission.pilot = 'Enfield 1-1'
Mission.Troops = GROUP:FindByName("Troops")
Mission.TroopCargo = CARGO_GROUP:New( Mission.Troops, "Troops", "Troops", 14 )

--Zones
Mission.Zones = {}
Mission.Zones.CapeTownLZ = ZONE:New('CapeTown')
Mission.Zones.CapeTownSafeArea = ZONE:New('CapeTownArea')
Mission.Zones.LZ_1_Area = ZONE:New('LZ_1_Area')
Mission.Zones.LZ_1 = ZONE:New('LZ_1')
Mission.Zones.LZ_2_Area = ZONE:New('LZ_2_Area')
Mission.Zones.LZ_2 = ZONE:New('LZ_2')
Mission.Zones.B_Trigger = ZONE:New('B_Trigger')

--Vars
Mission.Complete = false
Mission.SafeZoneAlert = false
Mission.TroopPickup = false
Mission.TroopDropOff = false

SPAWN:New( "Outpost 387 Infantry Defense-1" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 8, 5 ):SpawnScheduled( 3, .5 )
SPAWN:New( "Outpost 387 Infantry Defense-2" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 8, 5 ):SpawnScheduled( 3, .5 )
SPAWN:New( "Outpost 387 Infantry Defense-3" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 8, 5 ):SpawnScheduled( 3, .5 )
SPAWN:New( "Outpost 387 Infantry Defense-4" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 8, 5 ):SpawnScheduled( 3, .5 )
SPAWN:New( "Outpost 387 Infantry Defense-5" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 8, 5 ):SpawnScheduled( 3, .5 )

--Mission Functions
do
  function Mission:WelcomeMessage()
    SCHEDULER:New( nil, function() 
      USERSOUND:New( 'TheFraternityIntro.ogg' ):ToAll()
      MESSAGE:New('Welcome to The Fraternity...',10):ToAll()
      
        SCHEDULER:New( nil, 
        function()
          USERSOUND:New( 'chirp.ogg' ):ToAll()
          MESSAGE:New('We have our orders - we better get to it!',8,'Co-Pilot'):ToAll()
        end, {}, 12)
      
    end, {}, 3)
  end
  
  function Mission:EnenmyTerritoryCheck()
    Mission.safeZoneAlert = SCHEDULER:New( nil, function() 
    if GROUP:FindByName(Mission.pilot):IsInZone(Mission.Zones.CapeTownSafeArea) == false and Mission.SafeZoneAlert == false then
      Mission.SafeZoneAlert = true
      USERSOUND:New( "chirp.ogg" ):ToAll()
      MESSAGE:New('You are entering into enemy territory',8,'HQ'):ToAll()
      Mission.safeZoneAlert:Stop()
    end
  end, {}, 15,5)
  end
  
  function Mission:Smoke_LZ_1()
    Mission.LZ_1_Smoke = false
    Mission.LZ_1_SmokeSch = SCHEDULER:New( nil, function() 
    if GROUP:FindByName(Mission.pilot):IsInZone(Mission.Zones.LZ_1_Area) and Mission.LZ_1_Smoke == false then
       Mission.LZ_1_Smoke = true
       USERSOUND:New( "chirp.ogg" ):ToAll()
       MESSAGE:New('Enfield 1-1 we hearing you coming in, poping orange smoke.',10,"Major Arnold"):ToAll()
       UNIT:FindByName('APC 1'):SmokeOrange()
       Mission.LZ_1_SmokeSch:Stop()
      end 
    end, {}, 300,2)
  end
  
  function Mission:LZ_2_Flare_Red()
    Mission.LZ_2_Flare = false
    Mission.LZ_2_FlareSch = SCHEDULER:New( nil, function() 
    if GROUP:FindByName(Mission.pilot):IsInZone(Mission.Zones.LZ_2_Area) and Mission.LZ_2_Flare == false then
       Mission.LZ_2_Flare = true
       UNIT:FindByName('Outpost 387 Flare'):FlareRed()
        SCHEDULER:New( nil, 
        function()
          UNIT:FindByName('Outpost 387 Flare'):FlareRed()
        end, {}, 3,3,0,66)
       Mission.LZ_2_FlareSch:Stop()
      end 
    end, {}, 300,2)
  end
  
  function Mission:BoardTroops()
    if GROUP:FindByName(Mission.pilot):IsInZone(Mission.Zones.LZ_1) and Mission.TroopPickup == false then
    Mission.TroopPickup = true
      SCHEDULER:New( nil, 
        function()
          USERSOUND:New( 'get_to_the_choppa.ogg' ):ToAll()
          MESSAGE:New('Lets Get to the Choppaaa!!',8,'Major Arnold'):ToAll()

          Mission.TroopCargo:__Board(4, GROUP:FindByName(Mission.pilot), 14 )
          
        end, {}, 5)
    end
  end
  
  function Mission:StartBattleScene()
    
    Mission.BattleSceneStarted = false
    Mission.BattleSeneSch = SCHEDULER:New( nil, 
    function()
     if GROUP:FindByName(Mission.pilot):IsInZone(Mission.Zones.B_Trigger) and Mission.BattleSceneStarted == false then
        red1 = SPAWN:New( "Insurgents-1" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 3, 3 ):SpawnScheduled( 3, .5 )
        red2 = SPAWN:New( "Insurgents-2" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 3, 3 ):SpawnScheduled( math.random(2,4), .5 )
        red3 = SPAWN:New( "Insurgents-3" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 3, 3 ):SpawnScheduled( 3, .5 )
        red4 = SPAWN:New( "Insurgents-4" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 3, 3 ):SpawnScheduled( math.random(2,4), .5 )
        red5 = SPAWN:New( "Insurgents-5" ):InitLimit( 1, 0 ):InitRandomizePosition( true, 3, 3 ):SpawnScheduled( 3, .5 )
        
        SCHEDULER:New( nil, 
        function()
         USERSOUND:New( 'radioscratch.ogg' ):ToAll()
         MESSAGE:New('We are Under Attack!! Hurry with those troops!',8,'Outpost 387'):ToAll()
        end, {}, math.random(10,30))
        
        Mission.BattleSeneSch:Stop()
        
     end
    end, {}, 300,10)
    
  end
  
  function Mission:UnBoardTroops()
    if GROUP:FindByName(Mission.pilot):IsInZone(Mission.Zones.LZ_2) and Mission.TroopDropOff == false then
    Mission.TroopDropOff = true
      SCHEDULER:New( nil, 
        function()
          Mission.TroopCargo:__UnBoard(2, ZONE:New('Exit_Zone'):GetPointVec2())
          
          if UNIT:FindByName('Truck'):IsAlive() ~= nil then UNIT:FindByName('Truck'):Explode(15,10) end
          if UNIT:FindByName('Truck 2'):IsAlive() ~= nil then UNIT:FindByName('Truck 2'):Explode(15,25) end
          
          SCHEDULER:New( nil, 
            function()
            
              red1:SpawnScheduleStop()
              red2:SpawnScheduleStop()
              red3:SpawnScheduleStop()
              red4:SpawnScheduleStop()
              red5:SpawnScheduleStop()
              
            end, {}, 60)
          
        end, {}, 5)
    end
  end
  
  function Mission.MissionCompleteCheck()
    if GROUP:FindByName(Mission.pilot):IsInZone(Mission.Zones.CapeTownLZ) and Mission.TroopDropOff == true and Mission.Complete == false then
    Mission.Complete = true
      SCHEDULER:New( nil, 
        function()
          USERSOUND:New( 'chirp.ogg' ):ToAll()
          MESSAGE:New('Excellent job! Troops were drooped off successfully at there LZ.',10,'HQ'):ToAll()
          
        end, {}, 5)
    end
  end
end

--Events
Mission.EventHandler = EVENTHANDLER:New()
Mission.EventHandler:HandleEvent(EVENTS.Birth)
Mission.EventHandler:HandleEvent(EVENTS.Takeoff)
Mission.EventHandler:HandleEvent(EVENTS.Land)
Mission.EventHandler:HandleEvent(EVENTS.PilotDead)

--- @param Core.Event#EVENT self
-- @param Core.Event#EVENTDATA EventData
-- 
function Mission.EventHandler:OnEventBirth( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
  if PlayerGroup:GetName() == Mission.pilot then
    Mission:WelcomeMessage()
    Mission:Smoke_LZ_1()
    Mission:LZ_2_Flare_Red()
    Mission:StartBattleScene()
  end
  
end

--- @param Core.Event#EVENT self
-- @param Core.Event#EVENTDATA EventData
-- 
function Mission.EventHandler:OnEventTakeoff( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
  
  --Entering Enemy Territory
  Mission:EnenmyTerritoryCheck()
end

--- @param Core.Event#EVENT self
-- @param Core.Event#EVENTDATA EventData
-- 
function Mission.EventHandler:OnEventLand( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
  
  Mission:BoardTroops()
  Mission:UnBoardTroops()
  Mission.MissionCompleteCheck()
  
end
